from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.decomposition import LatentDirichletAllocation as LDA
from nltk.corpus import stopwords

corpus = []

docs = []
with open('data/test1.txt') as file:
    for line in file:
        corpus.append(line.rstrip())

count_vect = CountVectorizer(stop_words=stopwords.words('english'), lowercase=True)
x_counts = count_vect.fit_transform(corpus)
x_counts.todense()

x = count_vect.get_feature_names()
print(x)

tfidf_transformer = TfidfTransformer()
x_tfidf = tfidf_transformer.fit_transform(x_counts)

dimension = 1
lda = LDA(n_components=dimension)
lda_array = lda.fit_transform(x_tfidf)
lda_array

components = [lda.components_[i] for i in range(len(lda.components_))]
features = count_vect.get_feature_names()
important_words = [sorted(features, key=lambda x: components[j][features.index(x)], reverse=True)[:3] for j in
                   range(len(components))]
print(important_words)